<?php
/**
 * InlineObject15
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject15 Class Doc Comment
 *
 * @category Class
 * @description Here, the filter settings for the chat list are stored
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject15 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object_15';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'employeeId' => 'int',
        'onlyExpectedTimeExpired' => 'bool',
        'chatIds' => 'int[]',
        'status' => 'string',
        'searchString' => 'string',
        'linkTypeId' => 'int',
        'linkId' => 'int',
        'linkIds' => 'int[]',
        'creatorId' => 'int',
        'showOnlyParticapatedChat' => 'bool',
        'loadMessages' => 'string',
        'fillLinkedEntities' => 'bool',
        'minimumCreationDate' => 'int',
        'itemsPerPage' => 'int',
        'page' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'employeeId' => null,
        'onlyExpectedTimeExpired' => null,
        'chatIds' => null,
        'status' => null,
        'searchString' => null,
        'linkTypeId' => null,
        'linkId' => null,
        'linkIds' => null,
        'creatorId' => null,
        'showOnlyParticapatedChat' => null,
        'loadMessages' => null,
        'fillLinkedEntities' => null,
        'minimumCreationDate' => 'timestamp',
        'itemsPerPage' => null,
        'page' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'employeeId' => 'employeeId',
        'onlyExpectedTimeExpired' => 'onlyExpectedTimeExpired',
        'chatIds' => 'chatIds',
        'status' => 'status',
        'searchString' => 'searchString',
        'linkTypeId' => 'linkTypeId',
        'linkId' => 'linkId',
        'linkIds' => 'linkIds',
        'creatorId' => 'creatorId',
        'showOnlyParticapatedChat' => 'showOnlyParticapatedChat',
        'loadMessages' => 'loadMessages',
        'fillLinkedEntities' => 'fillLinkedEntities',
        'minimumCreationDate' => 'minimumCreationDate',
        'itemsPerPage' => 'itemsPerPage',
        'page' => 'page'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'employeeId' => 'setEmployeeId',
        'onlyExpectedTimeExpired' => 'setOnlyExpectedTimeExpired',
        'chatIds' => 'setChatIds',
        'status' => 'setStatus',
        'searchString' => 'setSearchString',
        'linkTypeId' => 'setLinkTypeId',
        'linkId' => 'setLinkId',
        'linkIds' => 'setLinkIds',
        'creatorId' => 'setCreatorId',
        'showOnlyParticapatedChat' => 'setShowOnlyParticapatedChat',
        'loadMessages' => 'setLoadMessages',
        'fillLinkedEntities' => 'setFillLinkedEntities',
        'minimumCreationDate' => 'setMinimumCreationDate',
        'itemsPerPage' => 'setItemsPerPage',
        'page' => 'setPage'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'employeeId' => 'getEmployeeId',
        'onlyExpectedTimeExpired' => 'getOnlyExpectedTimeExpired',
        'chatIds' => 'getChatIds',
        'status' => 'getStatus',
        'searchString' => 'getSearchString',
        'linkTypeId' => 'getLinkTypeId',
        'linkId' => 'getLinkId',
        'linkIds' => 'getLinkIds',
        'creatorId' => 'getCreatorId',
        'showOnlyParticapatedChat' => 'getShowOnlyParticapatedChat',
        'loadMessages' => 'getLoadMessages',
        'fillLinkedEntities' => 'getFillLinkedEntities',
        'minimumCreationDate' => 'getMinimumCreationDate',
        'itemsPerPage' => 'getItemsPerPage',
        'page' => 'getPage'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const STATUS_OPEN = 'OPEN';
    public const STATUS_CLOSED = 'CLOSED';
    public const LOAD_MESSAGES_NONE = 'NONE';
    public const LOAD_MESSAGES_ALL = 'ALL';
    public const LOAD_MESSAGES_LAST = 'LAST';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_OPEN,
            self::STATUS_CLOSED,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getLoadMessagesAllowableValues()
    {
        return [
            self::LOAD_MESSAGES_NONE,
            self::LOAD_MESSAGES_ALL,
            self::LOAD_MESSAGES_LAST,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['onlyExpectedTimeExpired'] = $data['onlyExpectedTimeExpired'] ?? null;
        $this->container['chatIds'] = $data['chatIds'] ?? null;
        $this->container['status'] = $data['status'] ?? null;
        $this->container['searchString'] = $data['searchString'] ?? null;
        $this->container['linkTypeId'] = $data['linkTypeId'] ?? null;
        $this->container['linkId'] = $data['linkId'] ?? null;
        $this->container['linkIds'] = $data['linkIds'] ?? null;
        $this->container['creatorId'] = $data['creatorId'] ?? null;
        $this->container['showOnlyParticapatedChat'] = $data['showOnlyParticapatedChat'] ?? null;
        $this->container['loadMessages'] = $data['loadMessages'] ?? null;
        $this->container['fillLinkedEntities'] = $data['fillLinkedEntities'] ?? null;
        $this->container['minimumCreationDate'] = $data['minimumCreationDate'] ?? null;
        $this->container['itemsPerPage'] = $data['itemsPerPage'] ?? null;
        $this->container['page'] = $data['page'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getStatusAllowableValues();
        if (!is_null($this->container['status']) && !in_array($this->container['status'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'status', must be one of '%s'",
                $this->container['status'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getLoadMessagesAllowableValues();
        if (!is_null($this->container['loadMessages']) && !in_array($this->container['loadMessages'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'loadMessages', must be one of '%s'",
                $this->container['loadMessages'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId filters chats for a given employee id. All chats will be returned to which this employee has access to
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets onlyExpectedTimeExpired
     *
     * @return bool|null
     */
    public function getOnlyExpectedTimeExpired()
    {
        return $this->container['onlyExpectedTimeExpired'];
    }

    /**
     * Sets onlyExpectedTimeExpired
     *
     * @param bool|null $onlyExpectedTimeExpired if true, only open chats with an expired expected time will be shown (overrides \"status\")
     *
     * @return self
     */
    public function setOnlyExpectedTimeExpired($onlyExpectedTimeExpired)
    {
        $this->container['onlyExpectedTimeExpired'] = $onlyExpectedTimeExpired;

        return $this;
    }

    /**
     * Gets chatIds
     *
     * @return int[]|null
     */
    public function getChatIds()
    {
        return $this->container['chatIds'];
    }

    /**
     * Sets chatIds
     *
     * @param int[]|null $chatIds if a list of specific chat ids shall be used, you can place the here
     *
     * @return self
     */
    public function setChatIds($chatIds)
    {
        $this->container['chatIds'] = $chatIds;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string|null $status Enum representing a the state of the chat
     *
     * @return self
     */
    public function setStatus($status)
    {
        $allowedValues = $this->getStatusAllowableValues();
        if (!is_null($status) && !in_array($status, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'status', must be one of '%s'",
                    $status,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets searchString
     *
     * @return string|null
     */
    public function getSearchString()
    {
        return $this->container['searchString'];
    }

    /**
     * Sets searchString
     *
     * @param string|null $searchString If chats shall be filtered for a given search text, this text goes here
     *
     * @return self
     */
    public function setSearchString($searchString)
    {
        $this->container['searchString'] = $searchString;

        return $this;
    }

    /**
     * Gets linkTypeId
     *
     * @return int|null
     */
    public function getLinkTypeId()
    {
        return $this->container['linkTypeId'];
    }

    /**
     * Sets linkTypeId
     *
     * @param int|null $linkTypeId linkType of assignment
     *
     * @return self
     */
    public function setLinkTypeId($linkTypeId)
    {
        $this->container['linkTypeId'] = $linkTypeId;

        return $this;
    }

    /**
     * Gets linkId
     *
     * @return int|null
     */
    public function getLinkId()
    {
        return $this->container['linkId'];
    }

    /**
     * Sets linkId
     *
     * @param int|null $linkId id of assignment
     *
     * @return self
     */
    public function setLinkId($linkId)
    {
        $this->container['linkId'] = $linkId;

        return $this;
    }

    /**
     * Gets linkIds
     *
     * @return int[]|null
     */
    public function getLinkIds()
    {
        return $this->container['linkIds'];
    }

    /**
     * Sets linkIds
     *
     * @param int[]|null $linkIds if multiple assignment ids schall be fetched, you can use an array of integers here
     *
     * @return self
     */
    public function setLinkIds($linkIds)
    {
        $this->container['linkIds'] = $linkIds;

        return $this;
    }

    /**
     * Gets creatorId
     *
     * @return int|null
     */
    public function getCreatorId()
    {
        return $this->container['creatorId'];
    }

    /**
     * Sets creatorId
     *
     * @param int|null $creatorId filters chats from this given chat creator
     *
     * @return self
     */
    public function setCreatorId($creatorId)
    {
        $this->container['creatorId'] = $creatorId;

        return $this;
    }

    /**
     * Gets showOnlyParticapatedChat
     *
     * @return bool|null
     */
    public function getShowOnlyParticapatedChat()
    {
        return $this->container['showOnlyParticapatedChat'];
    }

    /**
     * Sets showOnlyParticapatedChat
     *
     * @param bool|null $showOnlyParticapatedChat if true, only returns chats which the employee is assigned as creator or participant. Otherwise returns all chats whith access.
     *
     * @return self
     */
    public function setShowOnlyParticapatedChat($showOnlyParticapatedChat)
    {
        $this->container['showOnlyParticapatedChat'] = $showOnlyParticapatedChat;

        return $this;
    }

    /**
     * Gets loadMessages
     *
     * @return string|null
     */
    public function getLoadMessages()
    {
        return $this->container['loadMessages'];
    }

    /**
     * Sets loadMessages
     *
     * @param string|null $loadMessages describes if/which messages shall be loaded in a chat list
     *
     * @return self
     */
    public function setLoadMessages($loadMessages)
    {
        $allowedValues = $this->getLoadMessagesAllowableValues();
        if (!is_null($loadMessages) && !in_array($loadMessages, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'loadMessages', must be one of '%s'",
                    $loadMessages,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['loadMessages'] = $loadMessages;

        return $this;
    }

    /**
     * Gets fillLinkedEntities
     *
     * @return bool|null
     */
    public function getFillLinkedEntities()
    {
        return $this->container['fillLinkedEntities'];
    }

    /**
     * Sets fillLinkedEntities
     *
     * @param bool|null $fillLinkedEntities if true, the \"linked entities\" will be filled as well (with information regarding employees, tickets etc.)
     *
     * @return self
     */
    public function setFillLinkedEntities($fillLinkedEntities)
    {
        $this->container['fillLinkedEntities'] = $fillLinkedEntities;

        return $this;
    }

    /**
     * Gets minimumCreationDate
     *
     * @return int|null
     */
    public function getMinimumCreationDate()
    {
        return $this->container['minimumCreationDate'];
    }

    /**
     * Sets minimumCreationDate
     *
     * @param int|null $minimumCreationDate only returns chats with at least the given creation date
     *
     * @return self
     */
    public function setMinimumCreationDate($minimumCreationDate)
    {
        $this->container['minimumCreationDate'] = $minimumCreationDate;

        return $this;
    }

    /**
     * Gets itemsPerPage
     *
     * @return int|null
     */
    public function getItemsPerPage()
    {
        return $this->container['itemsPerPage'];
    }

    /**
     * Sets itemsPerPage
     *
     * @param int|null $itemsPerPage if pagination is used, you can enter the number of items per page
     *
     * @return self
     */
    public function setItemsPerPage($itemsPerPage)
    {
        $this->container['itemsPerPage'] = $itemsPerPage;

        return $this;
    }

    /**
     * Gets page
     *
     * @return int|null
     */
    public function getPage()
    {
        return $this->container['page'];
    }

    /**
     * Sets page
     *
     * @param int|null $page if pagination is used, you can enter the page number here
     *
     * @return self
     */
    public function setPage($page)
    {
        $this->container['page'] = $page;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


